// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from wallet.djinni

#ifndef DJINNI_GENERATED_COSMOSGASLIMITREQUEST_HPP
#define DJINNI_GENERATED_COSMOSGASLIMITREQUEST_HPP

#include "../utils/optional.hpp"
#include <iostream>
#include <memory>
#include <string>
#include <utility>
#include <vector>

namespace ledger { namespace core { namespace api {

class CosmosLikeMessage;

/** Class representing a GasLimit request for the Gaia node */
struct CosmosGasLimitRequest final {
    /** Memo field of the contract transaction */
    std::experimental::optional<std::string> memo;
    /** Messages to query gas for */
    std::vector<std::shared_ptr<CosmosLikeMessage>> messages;
    /**
     * Amplifier coefficient for safety
     * The transaction is more expensive usually because we send a smaller
     * payload than usual to the simulation backend (and gas is also consumed
     * per tx byte)
     */
    std::experimental::optional<std::string> amplifier;

    CosmosGasLimitRequest(std::experimental::optional<std::string> memo_,
                          std::vector<std::shared_ptr<CosmosLikeMessage>> messages_,
                          std::experimental::optional<std::string> amplifier_)
    : memo(std::move(memo_))
    , messages(std::move(messages_))
    , amplifier(std::move(amplifier_))
    {}

    CosmosGasLimitRequest(const CosmosGasLimitRequest& cpy) {
       this->memo = cpy.memo;
       this->messages = cpy.messages;
       this->amplifier = cpy.amplifier;
    }

    CosmosGasLimitRequest() = default;


    CosmosGasLimitRequest& operator=(const CosmosGasLimitRequest& cpy) {
       this->memo = cpy.memo;
       this->messages = cpy.messages;
       this->amplifier = cpy.amplifier;
       return *this;
    }

    template <class Archive>
    void load(Archive& archive) {
        archive(memo, messages, amplifier);
    }

    template <class Archive>
    void save(Archive& archive) const {
        archive(memo, messages, amplifier);
    }
};

} } }  // namespace ledger::core::api
#endif //DJINNI_GENERATED_COSMOSGASLIMITREQUEST_HPP
