// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from database.djinni

#ifndef DJINNI_GENERATED_DATABASERESULTROW_HPP
#define DJINNI_GENERATED_DATABASERESULTROW_HPP

#include <cstdint>
#include <memory>
#include <string>
#ifndef LIBCORE_EXPORT
    #if defined(_MSC_VER)
       #include <libcore_export.h>
    #else
       #define LIBCORE_EXPORT
    #endif
#endif

namespace ledger { namespace core { namespace api {

class DatabaseBlob;

/**
 * A table of data representing a database query result, which is usually generated by executing a statement that queries the database.
 * DatabaseResultRow instances are not expected to live once DatabaseResultSet::next has been called on its parent result set.
 */
class DatabaseResultRow {
public:
    virtual ~DatabaseResultRow() {}

    /**
     * Check if the value is NULL at the given position.
     * @return true if the value is NULL, false otherwise.
     */
    virtual bool isNullAtPos(int32_t pos) = 0;

    /**
     * Get the column name at the given position.
     * @return the column name.
     */
    virtual std::string getColumnName(int32_t pos) = 0;

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    virtual int16_t getShortByPos(int32_t pos) = 0;

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    virtual int32_t getIntByPos(int32_t pos) = 0;

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    virtual float getFloatByPos(int32_t pos) = 0;

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    virtual double getDoubleByPos(int32_t pos) = 0;

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    virtual int64_t getLongByPos(int32_t pos) = 0;

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    virtual std::string getStringByPos(int32_t pos) = 0;

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    virtual std::shared_ptr<DatabaseBlob> getBlobByPos(int32_t pos) = 0;
};

} } }  // namespace ledger::core::api
#endif //DJINNI_GENERATED_DATABASERESULTROW_HPP
