// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from stellar_like_wallet.djinni

#ifndef DJINNI_GENERATED_STELLARLIKEACCOUNT_HPP
#define DJINNI_GENERATED_STELLARLIKEACCOUNT_HPP

#include <cstdint>
#include <memory>
#include <vector>
#ifndef LIBCORE_EXPORT
    #if defined(_MSC_VER)
       #include <libcore_export.h>
    #else
       #define LIBCORE_EXPORT
    #endif
#endif

namespace ledger { namespace core { namespace api {

class AmountCallback;
class BigIntCallback;
class BoolCallback;
class StellarLikeAccountSignerListCallback;
class StellarLikeFeeStatsCallback;
class StellarLikeTransactionBuilder;
class StringCallback;

class LIBCORE_EXPORT StellarLikeAccount {
public:
    virtual ~StellarLikeAccount() {}

    /**
     * Checks if the current account exists on the stellar Network. If it doesn't the account needs to be activated by
     * sending an account creation operation with an amount of at least the base reserve.
     * @return Callback with a boolean indicating if the account exists on the Stellar network or not.
     */
    virtual void exists(const std::shared_ptr<BoolCallback> & callback) = 0;

    /**
     * Create a new transaction builder to create new transaction
     * @return The transaction builder
     */
    virtual std::shared_ptr<StellarLikeTransactionBuilder> buildTransaction() = 0;

    /** Broadcast the given raw transaction to the network. */
    virtual void broadcastRawTransaction(const std::vector<uint8_t> & tx, const std::shared_ptr<StringCallback> & callback) = 0;

    /** Get base reserve of the network */
    virtual void getBaseReserve(const std::shared_ptr<AmountCallback> & callback) = 0;

    /** Get sequence number to be used in the next transaction */
    virtual void getSequence(const std::shared_ptr<BigIntCallback> & callback) = 0;

    /** Get recommended fee */
    virtual void getFeeStats(const std::shared_ptr<StellarLikeFeeStatsCallback> & callback) = 0;

    /** Get signers for this account */
    virtual void getSigners(const std::shared_ptr<StellarLikeAccountSignerListCallback> & callback) = 0;
};

} } }  // namespace ledger::core::api
#endif //DJINNI_GENERATED_STELLARLIKEACCOUNT_HPP
