// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from tezos_like_wallet.djinni

#ifndef DJINNI_GENERATED_TEZOSLIKEORIGINATEDACCOUNT_HPP
#define DJINNI_GENERATED_TEZOSLIKEORIGINATEDACCOUNT_HPP

#include "../utils/optional.hpp"
#include <chrono>
#include <memory>
#include <string>
#ifndef LIBCORE_EXPORT
    #if defined(_MSC_VER)
       #include <libcore_export.h>
    #else
       #define LIBCORE_EXPORT
    #endif
#endif

namespace ledger { namespace core { namespace api {

class AmountCallback;
class AmountListCallback;
class OperationQuery;
class TezosLikeTransactionBuilder;
enum class TimePeriod;

/** Class representing originated accounts */
class LIBCORE_EXPORT TezosLikeOriginatedAccount {
public:
    virtual ~TezosLikeOriginatedAccount() {}

    /** Get address of originated account (prefixed with KT) */
    virtual std::string getAddress() = 0;

    /**
     * Get publicKey of originated account
     * Could be empty if not yet revealed
     */
    virtual std::experimental::optional<std::string> getPublicKey() = 0;

    /** Get balance of originated account */
    virtual void getBalance(const std::shared_ptr<AmountCallback> & callback) = 0;

    /** Get balance history of originated account */
    virtual void getBalanceHistory(const std::chrono::system_clock::time_point & start, const std::chrono::system_clock::time_point & end, TimePeriod period, const std::shared_ptr<AmountListCallback> & callback) = 0;

    /**
     * Know if possible to spend from this account
     * By default originations from libcore set it to true
     */
    virtual bool isSpendable() = 0;

    /**
     * Know if possible to delegate from this account
     * By default originations from libcore set it to true
     */
    virtual bool isDelegatable() = 0;

    /** Get related operations to account */
    virtual std::shared_ptr<OperationQuery> queryOperations() = 0;

    /** Get builder to construct transaction on originated account */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> buildTransaction() = 0;
};

} } }  // namespace ledger::core::api
#endif //DJINNI_GENERATED_TEZOSLIKEORIGINATEDACCOUNT_HPP
