// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from tezos_like_wallet.djinni

#ifndef DJINNI_GENERATED_TEZOSLIKETRANSACTIONBUILDER_HPP
#define DJINNI_GENERATED_TEZOSLIKETRANSACTIONBUILDER_HPP

#include <cstdint>
#include <memory>
#include <string>
#include <vector>
#ifndef LIBCORE_EXPORT
    #if defined(_MSC_VER)
       #include <libcore_export.h>
    #else
       #define LIBCORE_EXPORT
    #endif
#endif

namespace ledger { namespace core { namespace api {

class Amount;
class BigInt;
class TezosLikeTransaction;
class TezosLikeTransactionCallback;
enum class TezosOperationTag;
struct Currency;

class LIBCORE_EXPORT TezosLikeTransactionBuilder {
public:
    virtual ~TezosLikeTransactionBuilder() {}

    /**
     * Set type of operation (transaction, origination, reveal ...)
     * Default operation is "transaction" type
     */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> setType(TezosOperationTag type) = 0;

    /**
     * Send funds to the given address. This method can be called multiple times to send to multiple addresses.
     * @param amount The value to send
     * @param address Address of the recipient
     * @return A reference on the same builder in order to chain calls.
     */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> sendToAddress(const std::shared_ptr<Amount> & amount, const std::string & address) = 0;

    /**
     * Send all available funds to the given address.
     * @param address Address of the recipient
     * @return A reference on the same builder in order to chain calls.
     */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> wipeToAddress(const std::string & address) = 0;

    /**
     * Set fees (in drop) the originator is willing to pay
     * @return A reference on the same builder in order to chain calls.
     */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> setFees(const std::shared_ptr<Amount> & fees) = 0;

    /**
     * Set gas limit the originator is not willing to exceed.
     * @return A reference on the same builder in order to chain calls.
     */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> setGasLimit(const std::shared_ptr<Amount> & gasLimit) = 0;

    /**
     * Set storage limit the originator is not willing to exceed.
     * Reference : https://tezos.gitlab.io/zeronet/whitedoc/michelson.html
     * @return A reference on the same builder in order to chain calls.
     */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> setStorageLimit(const std::shared_ptr<BigInt> & storageLimit) = 0;

    /** Build a transaction from the given builder parameters. */
    virtual void build(const std::shared_ptr<TezosLikeTransactionCallback> & callback) = 0;

    /**
     * Creates a clone of this builder.
     * @return A copy of the current builder instance.
     */
    virtual std::shared_ptr<TezosLikeTransactionBuilder> clone() = 0;

    /** Reset the current instance to its initial state */
    virtual void reset() = 0;

    static std::shared_ptr<TezosLikeTransaction> parseRawUnsignedTransaction(const Currency & currency, const std::vector<uint8_t> & rawTransaction);

    static std::shared_ptr<TezosLikeTransaction> parseRawSignedTransaction(const Currency & currency, const std::vector<uint8_t> & rawTransaction);
};

} } }  // namespace ledger::core::api
#endif //DJINNI_GENERATED_TEZOSLIKETRANSACTIONBUILDER_HPP
