// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from wallet.djinni

#include "NJSAccountCpp.hpp"
#include "NJSObjectWrapper.hpp"
#include "NJSHexUtils.hpp"

using namespace v8;
using namespace node;
using namespace std;

NAN_METHOD(NJSAccount::getIndex) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getIndex needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getIndex : implementation of Account is not valid");
    }

    auto result = cpp_impl->getIndex();

    //Wrap result in node object
    auto arg_0 = Nan::New<Int32>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::queryOperations) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::queryOperations needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::queryOperations : implementation of Account is not valid");
    }

    auto result = cpp_impl->queryOperations();

    //Wrap result in node object
    auto arg_0 = NJSOperationQuery::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::getBalance) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getBalance needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAmountCallback *njs_ptr_arg_0 = new NJSAmountCallback(arg_0_resolver);
    std::shared_ptr<NJSAmountCallback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getBalance : implementation of Account is not valid");
    }
    cpp_impl->getBalance(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSAccount::getBalanceHistory) {

    //Check if method called with right number of arguments
    if(info.Length() != 3)
    {
        return Nan::ThrowError("NJSAccount::getBalanceHistory needs 3 arguments");
    }

    //Check if parameters have correct types
    Nan::Utf8String string_arg_0(info[0]->ToString(Nan::GetCurrentContext()).ToLocalChecked());
    auto arg_0 = std::string(*string_arg_0);
    Nan::Utf8String string_arg_1(info[1]->ToString(Nan::GetCurrentContext()).ToLocalChecked());
    auto arg_1 = std::string(*string_arg_1);
    auto arg_2 = (ledger::core::api::TimePeriod)Nan::To<int>(info[2]).FromJust();

    //Create promise and set it into Callback
    auto arg_3_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAmountListCallback *njs_ptr_arg_3 = new NJSAmountListCallback(arg_3_resolver);
    std::shared_ptr<NJSAmountListCallback> arg_3(njs_ptr_arg_3);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getBalanceHistory : implementation of Account is not valid");
    }
    cpp_impl->getBalanceHistory(arg_0,arg_1,arg_2,arg_3);
    info.GetReturnValue().Set(arg_3_resolver->GetPromise());
}
NAN_METHOD(NJSAccount::isSynchronizing) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::isSynchronizing needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::isSynchronizing : implementation of Account is not valid");
    }

    auto result = cpp_impl->isSynchronizing();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::synchronize) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::synchronize needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::synchronize : implementation of Account is not valid");
    }

    auto result = cpp_impl->synchronize();

    //Wrap result in node object
    auto arg_0 = NJSEventBus::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::getPreferences) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getPreferences needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getPreferences : implementation of Account is not valid");
    }

    auto result = cpp_impl->getPreferences();

    //Wrap result in node object
    auto arg_0 = NJSPreferences::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::getLogger) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getLogger needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getLogger : implementation of Account is not valid");
    }

    auto result = cpp_impl->getLogger();

    //Wrap result in node object
    auto arg_0 = NJSLogger::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::getOperationPreferences) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSAccount::getOperationPreferences needs 1 arguments");
    }

    //Check if parameters have correct types
    Nan::Utf8String string_arg_0(info[0]->ToString(Nan::GetCurrentContext()).ToLocalChecked());
    auto arg_0 = std::string(*string_arg_0);

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getOperationPreferences : implementation of Account is not valid");
    }

    auto result = cpp_impl->getOperationPreferences(arg_0);

    //Wrap result in node object
    auto arg_1 = NJSPreferences::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_1);
}
NAN_METHOD(NJSAccount::asBitcoinLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::asBitcoinLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::asBitcoinLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->asBitcoinLikeAccount();

    //Wrap result in node object
    auto arg_0 = NJSBitcoinLikeAccount::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::asCosmosLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::asCosmosLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::asCosmosLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->asCosmosLikeAccount();

    //Wrap result in node object
    auto arg_0 = NJSCosmosLikeAccount::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::asEthereumLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::asEthereumLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::asEthereumLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->asEthereumLikeAccount();

    //Wrap result in node object
    auto arg_0 = NJSEthereumLikeAccount::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::asRippleLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::asRippleLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::asRippleLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->asRippleLikeAccount();

    //Wrap result in node object
    auto arg_0 = NJSRippleLikeAccount::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::asTezosLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::asTezosLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::asTezosLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->asTezosLikeAccount();

    //Wrap result in node object
    auto arg_0 = NJSTezosLikeAccount::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::asAlgorandAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::asAlgorandAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::asAlgorandAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->asAlgorandAccount();

    //Wrap result in node object
    auto arg_0 = NJSAlgorandAccount::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::asStellarLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::asStellarLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::asStellarLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->asStellarLikeAccount();

    //Wrap result in node object
    auto arg_0 = NJSStellarLikeAccount::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::isInstanceOfBitcoinLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfBitcoinLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfBitcoinLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->isInstanceOfBitcoinLikeAccount();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::isInstanceOfCosmosLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfCosmosLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfCosmosLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->isInstanceOfCosmosLikeAccount();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::isInstanceOfEthereumLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfEthereumLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfEthereumLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->isInstanceOfEthereumLikeAccount();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::isInstanceOfStellarLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfStellarLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfStellarLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->isInstanceOfStellarLikeAccount();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::isInstanceOfRippleLikeAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfRippleLikeAccount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::isInstanceOfRippleLikeAccount : implementation of Account is not valid");
    }

    auto result = cpp_impl->isInstanceOfRippleLikeAccount();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::getFreshPublicAddresses) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getFreshPublicAddresses needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAddressListCallback *njs_ptr_arg_0 = new NJSAddressListCallback(arg_0_resolver);
    std::shared_ptr<NJSAddressListCallback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getFreshPublicAddresses : implementation of Account is not valid");
    }
    cpp_impl->getFreshPublicAddresses(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSAccount::getWalletType) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getWalletType needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getWalletType : implementation of Account is not valid");
    }

    auto result = cpp_impl->getWalletType();

    //Wrap result in node object
    auto arg_0 = Nan::New<Integer>((int)result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::getEventBus) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getEventBus needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getEventBus : implementation of Account is not valid");
    }

    auto result = cpp_impl->getEventBus();

    //Wrap result in node object
    auto arg_0 = NJSEventBus::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::startBlockchainObservation) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::startBlockchainObservation needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::startBlockchainObservation : implementation of Account is not valid");
    }
    cpp_impl->startBlockchainObservation();
}
NAN_METHOD(NJSAccount::stopBlockchainObservation) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::stopBlockchainObservation needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::stopBlockchainObservation : implementation of Account is not valid");
    }
    cpp_impl->stopBlockchainObservation();
}
NAN_METHOD(NJSAccount::isObservingBlockchain) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::isObservingBlockchain needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::isObservingBlockchain : implementation of Account is not valid");
    }

    auto result = cpp_impl->isObservingBlockchain();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::getLastBlock) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getLastBlock needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSBlockCallback *njs_ptr_arg_0 = new NJSBlockCallback(arg_0_resolver);
    std::shared_ptr<NJSBlockCallback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getLastBlock : implementation of Account is not valid");
    }
    cpp_impl->getLastBlock(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSAccount::getRestoreKey) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getRestoreKey needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getRestoreKey : implementation of Account is not valid");
    }

    auto result = cpp_impl->getRestoreKey();

    //Wrap result in node object
    auto arg_0 = Nan::New<String>(result).ToLocalChecked();

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSAccount::eraseDataSince) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSAccount::eraseDataSince needs 1 arguments");
    }

    //Check if parameters have correct types
    auto time_arg_0 = Nan::To<int32_t>(info[0]).FromJust();
    auto arg_0 = chrono::system_clock::time_point(chrono::milliseconds(time_arg_0));

    //Create promise and set it into Callback
    auto arg_1_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSErrorCodeCallback *njs_ptr_arg_1 = new NJSErrorCodeCallback(arg_1_resolver);
    std::shared_ptr<NJSErrorCodeCallback> arg_1(njs_ptr_arg_1);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::eraseDataSince : implementation of Account is not valid");
    }
    cpp_impl->eraseDataSince(arg_0,arg_1);
    info.GetReturnValue().Set(arg_1_resolver->GetPromise());
}
NAN_METHOD(NJSAccount::getAccountKeychain) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSAccount::getAccountKeychain needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSAccount::getAccountKeychain : implementation of Account is not valid");
    }

    auto result = cpp_impl->getAccountKeychain();

    //Wrap result in node object
    auto arg_0 = NJSKeychain::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}

NAN_METHOD(NJSAccount::New) {
    //Only new allowed
    if(!info.IsConstructCall())
    {
        return Nan::ThrowError("NJSAccount function can only be called as constructor (use New)");
    }
    info.GetReturnValue().Set(info.This());
}


Nan::Persistent<ObjectTemplate> NJSAccount::Account_prototype;

Local<Object> NJSAccount::wrap(const std::shared_ptr<ledger::core::api::Account> &object) {
    Nan::EscapableHandleScope scope;
    Local<ObjectTemplate> local_prototype = Nan::New(Account_prototype);

    Local<Object> obj;
    if(!local_prototype.IsEmpty())
    {
        obj = local_prototype->NewInstance(Nan::GetCurrentContext()).ToLocalChecked();
        djinni::js::ObjectWrapper<ledger::core::api::Account>::Wrap(object, obj);
    }
    else
    {
        Nan::ThrowError("NJSAccount::wrap: object template not valid");
    }
    return scope.Escape(obj);
}

NAN_METHOD(NJSAccount::isNull) {
    auto cpp_implementation = djinni::js::ObjectWrapper<ledger::core::api::Account>::Unwrap(info.This());
    auto isNull = !cpp_implementation ? true : false;
    return info.GetReturnValue().Set(Nan::New<Boolean>(isNull));
}

void NJSAccount::Initialize(Local<Object> target) {
    Nan::HandleScope scope;

    Local<FunctionTemplate> func_template = Nan::New<FunctionTemplate>(NJSAccount::New);
    Local<ObjectTemplate> objectTemplate = func_template->InstanceTemplate();
    objectTemplate->SetInternalFieldCount(1);

    func_template->SetClassName(Nan::New<String>("NJSAccount").ToLocalChecked());

    //SetPrototypeMethod all methods
    Nan::SetPrototypeMethod(func_template,"getIndex", getIndex);
    Nan::SetPrototypeMethod(func_template,"queryOperations", queryOperations);
    Nan::SetPrototypeMethod(func_template,"getBalance", getBalance);
    Nan::SetPrototypeMethod(func_template,"getBalanceHistory", getBalanceHistory);
    Nan::SetPrototypeMethod(func_template,"isSynchronizing", isSynchronizing);
    Nan::SetPrototypeMethod(func_template,"synchronize", synchronize);
    Nan::SetPrototypeMethod(func_template,"getPreferences", getPreferences);
    Nan::SetPrototypeMethod(func_template,"getLogger", getLogger);
    Nan::SetPrototypeMethod(func_template,"getOperationPreferences", getOperationPreferences);
    Nan::SetPrototypeMethod(func_template,"asBitcoinLikeAccount", asBitcoinLikeAccount);
    Nan::SetPrototypeMethod(func_template,"asCosmosLikeAccount", asCosmosLikeAccount);
    Nan::SetPrototypeMethod(func_template,"asEthereumLikeAccount", asEthereumLikeAccount);
    Nan::SetPrototypeMethod(func_template,"asRippleLikeAccount", asRippleLikeAccount);
    Nan::SetPrototypeMethod(func_template,"asTezosLikeAccount", asTezosLikeAccount);
    Nan::SetPrototypeMethod(func_template,"asAlgorandAccount", asAlgorandAccount);
    Nan::SetPrototypeMethod(func_template,"asStellarLikeAccount", asStellarLikeAccount);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfBitcoinLikeAccount", isInstanceOfBitcoinLikeAccount);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfCosmosLikeAccount", isInstanceOfCosmosLikeAccount);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfEthereumLikeAccount", isInstanceOfEthereumLikeAccount);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfStellarLikeAccount", isInstanceOfStellarLikeAccount);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfRippleLikeAccount", isInstanceOfRippleLikeAccount);
    Nan::SetPrototypeMethod(func_template,"getFreshPublicAddresses", getFreshPublicAddresses);
    Nan::SetPrototypeMethod(func_template,"getWalletType", getWalletType);
    Nan::SetPrototypeMethod(func_template,"getEventBus", getEventBus);
    Nan::SetPrototypeMethod(func_template,"startBlockchainObservation", startBlockchainObservation);
    Nan::SetPrototypeMethod(func_template,"stopBlockchainObservation", stopBlockchainObservation);
    Nan::SetPrototypeMethod(func_template,"isObservingBlockchain", isObservingBlockchain);
    Nan::SetPrototypeMethod(func_template,"getLastBlock", getLastBlock);
    Nan::SetPrototypeMethod(func_template,"getRestoreKey", getRestoreKey);
    Nan::SetPrototypeMethod(func_template,"eraseDataSince", eraseDataSince);
    Nan::SetPrototypeMethod(func_template,"getAccountKeychain", getAccountKeychain);
    Nan::SetPrototypeMethod(func_template,"isNull", isNull);
    //Set object prototype
    Account_prototype.Reset(objectTemplate);

    //Add template to target
    Nan::Set(target, Nan::New<String>("NJSAccount").ToLocalChecked(), Nan::GetFunction(func_template).ToLocalChecked());
}
