// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from database.djinni

#ifndef DJINNI_GENERATED_NJSDATABASERESULTROW_HPP
#define DJINNI_GENERATED_NJSDATABASERESULTROW_HPP


#include "../include/DatabaseBlob.hpp"
#include "NJSDatabaseBlob.hpp"
#include <cstdint>
#include <memory>
#include <string>

#include <nan.h>
#include <node.h>
#include "../include/DatabaseResultRow.hpp"

using namespace v8;
using namespace node;
using namespace std;
using namespace ledger::core::api;

class NJSDatabaseResultRow: public ledger::core::api::DatabaseResultRow {
public:

    static void Initialize(Local<Object> target);

    static Local<Object> wrap(const std::shared_ptr<ledger::core::api::DatabaseResultRow> &object);
    static Nan::Persistent<ObjectTemplate> DatabaseResultRow_prototype;
    ~NJSDatabaseResultRow()
    {
        njs_impl.Reset();
    };
    NJSDatabaseResultRow(Local<Object> njs_implementation){njs_impl.Reset(njs_implementation);};

    /**
     * Check if the value is NULL at the given position.
     * @return true if the value is NULL, false otherwise.
     */
    bool isNullAtPos(int32_t pos);

    /**
     * Get the column name at the given position.
     * @return the column name.
     */
    std::string getColumnName(int32_t pos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    int16_t getShortByPos(int32_t pos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    int32_t getIntByPos(int32_t pos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    float getFloatByPos(int32_t pos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    double getDoubleByPos(int32_t pos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    int64_t getLongByPos(int32_t pos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    std::string getStringByPos(int32_t pos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    std::shared_ptr<DatabaseBlob> getBlobByPos(int32_t pos);

private:
    /**
     * Check if the value is NULL at the given position.
     * @return true if the value is NULL, false otherwise.
     */
    static NAN_METHOD(isNullAtPos);

    /**
     * Get the column name at the given position.
     * @return the column name.
     */
    static NAN_METHOD(getColumnName);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    static NAN_METHOD(getShortByPos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    static NAN_METHOD(getIntByPos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    static NAN_METHOD(getFloatByPos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    static NAN_METHOD(getDoubleByPos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    static NAN_METHOD(getLongByPos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    static NAN_METHOD(getStringByPos);

    /**
     * Get the value at the given position. The underneath value has to be an 16bit integer otherwise this call will fail.
     * @return the value at the given position.
     */
    static NAN_METHOD(getBlobByPos);

    static NAN_METHOD(New);

    Nan::Persistent<Object> njs_impl;
};
#endif //DJINNI_GENERATED_NJSDATABASERESULTROW_HPP
