// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from ripple_like_wallet.djinni

#include "NJSRippleLikeBlockCpp.hpp"
#include "NJSObjectWrapper.hpp"
#include "NJSHexUtils.hpp"

using namespace v8;
using namespace node;
using namespace std;

NAN_METHOD(NJSRippleLikeBlock::getHash) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSRippleLikeBlock::getHash needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::RippleLikeBlock>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSRippleLikeBlock::getHash : implementation of RippleLikeBlock is not valid");
    }

    auto result = cpp_impl->getHash();

    //Wrap result in node object
    auto arg_0 = Nan::New<String>(result).ToLocalChecked();

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSRippleLikeBlock::getHeight) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSRippleLikeBlock::getHeight needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::RippleLikeBlock>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSRippleLikeBlock::getHeight : implementation of RippleLikeBlock is not valid");
    }

    auto result = cpp_impl->getHeight();

    //Wrap result in node object
    auto arg_0 = Nan::New<Number>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSRippleLikeBlock::getTime) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSRippleLikeBlock::getTime needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::RippleLikeBlock>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSRippleLikeBlock::getTime : implementation of RippleLikeBlock is not valid");
    }

    auto result = cpp_impl->getTime();

    //Wrap result in node object
    auto date_arg_0 = chrono::duration_cast<chrono::milliseconds>(result.time_since_epoch()).count();
    auto arg_0 = Nan::New<Date>(date_arg_0).ToLocalChecked();

    //Return result
    info.GetReturnValue().Set(arg_0);
}

NAN_METHOD(NJSRippleLikeBlock::New) {
    //Only new allowed
    if(!info.IsConstructCall())
    {
        return Nan::ThrowError("NJSRippleLikeBlock function can only be called as constructor (use New)");
    }
    info.GetReturnValue().Set(info.This());
}


Nan::Persistent<ObjectTemplate> NJSRippleLikeBlock::RippleLikeBlock_prototype;

Local<Object> NJSRippleLikeBlock::wrap(const std::shared_ptr<ledger::core::api::RippleLikeBlock> &object) {
    Nan::EscapableHandleScope scope;
    Local<ObjectTemplate> local_prototype = Nan::New(RippleLikeBlock_prototype);

    Local<Object> obj;
    if(!local_prototype.IsEmpty())
    {
        obj = local_prototype->NewInstance(Nan::GetCurrentContext()).ToLocalChecked();
        djinni::js::ObjectWrapper<ledger::core::api::RippleLikeBlock>::Wrap(object, obj);
    }
    else
    {
        Nan::ThrowError("NJSRippleLikeBlock::wrap: object template not valid");
    }
    return scope.Escape(obj);
}

NAN_METHOD(NJSRippleLikeBlock::isNull) {
    auto cpp_implementation = djinni::js::ObjectWrapper<ledger::core::api::RippleLikeBlock>::Unwrap(info.This());
    auto isNull = !cpp_implementation ? true : false;
    return info.GetReturnValue().Set(Nan::New<Boolean>(isNull));
}

void NJSRippleLikeBlock::Initialize(Local<Object> target) {
    Nan::HandleScope scope;

    Local<FunctionTemplate> func_template = Nan::New<FunctionTemplate>(NJSRippleLikeBlock::New);
    Local<ObjectTemplate> objectTemplate = func_template->InstanceTemplate();
    objectTemplate->SetInternalFieldCount(1);

    func_template->SetClassName(Nan::New<String>("NJSRippleLikeBlock").ToLocalChecked());

    //SetPrototypeMethod all methods
    Nan::SetPrototypeMethod(func_template,"getHash", getHash);
    Nan::SetPrototypeMethod(func_template,"getHeight", getHeight);
    Nan::SetPrototypeMethod(func_template,"getTime", getTime);
    Nan::SetPrototypeMethod(func_template,"isNull", isNull);
    //Set object prototype
    RippleLikeBlock_prototype.Reset(objectTemplate);

    //Add template to target
    Nan::Set(target, Nan::New<String>("NJSRippleLikeBlock").ToLocalChecked(), Nan::GetFunction(func_template).ToLocalChecked());
}
