// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from wallet.djinni

#include "NJSWalletCpp.hpp"
#include "NJSObjectWrapper.hpp"
#include "NJSHexUtils.hpp"

using namespace v8;
using namespace node;
using namespace std;

NAN_METHOD(NJSWallet::getName) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getName needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getName : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getName();

    //Wrap result in node object
    auto arg_0 = Nan::New<String>(result).ToLocalChecked();

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::getAccount) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSWallet::getAccount needs 1 arguments");
    }

    //Check if parameters have correct types
    auto arg_0 = Nan::To<int32_t>(info[0]).FromJust();

    //Create promise and set it into Callback
    auto arg_1_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAccountCallback *njs_ptr_arg_1 = new NJSAccountCallback(arg_1_resolver);
    std::shared_ptr<NJSAccountCallback> arg_1(njs_ptr_arg_1);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getAccount : implementation of Wallet is not valid");
    }
    cpp_impl->getAccount(arg_0,arg_1);
    info.GetReturnValue().Set(arg_1_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getAccountCount) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getAccountCount needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSI32Callback *njs_ptr_arg_0 = new NJSI32Callback(arg_0_resolver);
    std::shared_ptr<NJSI32Callback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getAccountCount : implementation of Wallet is not valid");
    }
    cpp_impl->getAccountCount(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getAccounts) {

    //Check if method called with right number of arguments
    if(info.Length() != 2)
    {
        return Nan::ThrowError("NJSWallet::getAccounts needs 2 arguments");
    }

    //Check if parameters have correct types
    auto arg_0 = Nan::To<int32_t>(info[0]).FromJust();
    auto arg_1 = Nan::To<int32_t>(info[1]).FromJust();

    //Create promise and set it into Callback
    auto arg_2_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAccountListCallback *njs_ptr_arg_2 = new NJSAccountListCallback(arg_2_resolver);
    std::shared_ptr<NJSAccountListCallback> arg_2(njs_ptr_arg_2);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getAccounts : implementation of Wallet is not valid");
    }
    cpp_impl->getAccounts(arg_0,arg_1,arg_2);
    info.GetReturnValue().Set(arg_2_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getNextAccountIndex) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getNextAccountIndex needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSI32Callback *njs_ptr_arg_0 = new NJSI32Callback(arg_0_resolver);
    std::shared_ptr<NJSI32Callback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getNextAccountIndex : implementation of Wallet is not valid");
    }
    cpp_impl->getNextAccountIndex(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getEventBus) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getEventBus needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getEventBus : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getEventBus();

    //Wrap result in node object
    auto arg_0 = NJSEventBus::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::isSynchronizing) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::isSynchronizing needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::isSynchronizing : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->isSynchronizing();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::synchronize) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::synchronize needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::synchronize : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->synchronize();

    //Wrap result in node object
    auto arg_0 = NJSEventBus::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::getPreferences) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getPreferences needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getPreferences : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getPreferences();

    //Wrap result in node object
    auto arg_0 = NJSPreferences::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::getLogger) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getLogger needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getLogger : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getLogger();

    //Wrap result in node object
    auto arg_0 = NJSLogger::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::getAccountPreferences) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSWallet::getAccountPreferences needs 1 arguments");
    }

    //Check if parameters have correct types
    auto arg_0 = Nan::To<int32_t>(info[0]).FromJust();

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getAccountPreferences : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getAccountPreferences(arg_0);

    //Wrap result in node object
    auto arg_1 = NJSPreferences::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_1);
}
NAN_METHOD(NJSWallet::asBitcoinLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::asBitcoinLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::asBitcoinLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->asBitcoinLikeWallet();

    //Wrap result in node object
    auto arg_0 = NJSBitcoinLikeWallet::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::asCosmosLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::asCosmosLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::asCosmosLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->asCosmosLikeWallet();

    //Wrap result in node object
    auto arg_0 = NJSCosmosLikeWallet::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::getCurrency) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getCurrency needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getCurrency : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getCurrency();

    //Wrap result in node object
    auto arg_0 = Nan::New<Object>();
    auto arg_0_1 = Nan::New<Integer>((int)result.walletType);
    Nan::DefineOwnProperty(arg_0, Nan::New<String>("walletType").ToLocalChecked(), arg_0_1);
    auto arg_0_2 = Nan::New<String>(result.name).ToLocalChecked();
    Nan::DefineOwnProperty(arg_0, Nan::New<String>("name").ToLocalChecked(), arg_0_2);
    auto arg_0_3 = Nan::New<Int32>(result.bip44CoinType);
    Nan::DefineOwnProperty(arg_0, Nan::New<String>("bip44CoinType").ToLocalChecked(), arg_0_3);
    auto arg_0_4 = Nan::New<String>(result.paymentUriScheme).ToLocalChecked();
    Nan::DefineOwnProperty(arg_0, Nan::New<String>("paymentUriScheme").ToLocalChecked(), arg_0_4);
    Local<Array> arg_0_5 = Nan::New<Array>();
    for(size_t arg_0_5_id = 0; arg_0_5_id < result.units.size(); arg_0_5_id++)
    {
        auto arg_0_5_elem = Nan::New<Object>();
        auto arg_0_5_elem_1 = Nan::New<String>(result.units[arg_0_5_id].name).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_5_elem, Nan::New<String>("name").ToLocalChecked(), arg_0_5_elem_1);
        auto arg_0_5_elem_2 = Nan::New<String>(result.units[arg_0_5_id].symbol).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_5_elem, Nan::New<String>("symbol").ToLocalChecked(), arg_0_5_elem_2);
        auto arg_0_5_elem_3 = Nan::New<String>(result.units[arg_0_5_id].code).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_5_elem, Nan::New<String>("code").ToLocalChecked(), arg_0_5_elem_3);
        auto arg_0_5_elem_4 = Nan::New<Int32>(result.units[arg_0_5_id].numberOfDecimal);
        Nan::DefineOwnProperty(arg_0_5_elem, Nan::New<String>("numberOfDecimal").ToLocalChecked(), arg_0_5_elem_4);

        Nan::Set(arg_0_5, (int)arg_0_5_id,arg_0_5_elem);
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("units").ToLocalChecked(), arg_0_5);
    Local<Value> arg_0_6;
    if(result.bitcoinLikeNetworkParameters)
    {
        auto arg_0_6_optional = (result.bitcoinLikeNetworkParameters).value();
        auto arg_0_6_tmp = Nan::New<Object>();
        auto arg_0_6_tmp_1 = Nan::New<String>(arg_0_6_optional.Identifier).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("Identifier").ToLocalChecked(), arg_0_6_tmp_1);
        auto arg_0_6_tmp_2 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_6_optional.P2PKHVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("P2PKHVersion").ToLocalChecked(), arg_0_6_tmp_2);
        auto arg_0_6_tmp_3 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_6_optional.P2SHVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("P2SHVersion").ToLocalChecked(), arg_0_6_tmp_3);
        auto arg_0_6_tmp_4 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_6_optional.XPUBVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("XPUBVersion").ToLocalChecked(), arg_0_6_tmp_4);
        auto arg_0_6_tmp_5 = Nan::New<Integer>((int)arg_0_6_optional.FeePolicy);
        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("FeePolicy").ToLocalChecked(), arg_0_6_tmp_5);
        auto arg_0_6_tmp_6 = Nan::New<Number>(arg_0_6_optional.DustAmount);
        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("DustAmount").ToLocalChecked(), arg_0_6_tmp_6);
        auto arg_0_6_tmp_7 = Nan::New<String>(arg_0_6_optional.MessagePrefix).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("MessagePrefix").ToLocalChecked(), arg_0_6_tmp_7);
        auto arg_0_6_tmp_8 = Nan::New<Boolean>(arg_0_6_optional.UsesTimestampedTransaction);
        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("UsesTimestampedTransaction").ToLocalChecked(), arg_0_6_tmp_8);
        auto arg_0_6_tmp_9 = Nan::New<Number>(arg_0_6_optional.TimestampDelay);
        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("TimestampDelay").ToLocalChecked(), arg_0_6_tmp_9);
        auto arg_0_6_tmp_10 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_6_optional.SigHash)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("SigHash").ToLocalChecked(), arg_0_6_tmp_10);
        Local<Array> arg_0_6_tmp_11 = Nan::New<Array>();
        for(size_t arg_0_6_tmp_11_id = 0; arg_0_6_tmp_11_id < arg_0_6_optional.AdditionalBIPs.size(); arg_0_6_tmp_11_id++)
        {
            auto arg_0_6_tmp_11_elem = Nan::New<String>(arg_0_6_optional.AdditionalBIPs[arg_0_6_tmp_11_id]).ToLocalChecked();
            Nan::Set(arg_0_6_tmp_11, (int)arg_0_6_tmp_11_id,arg_0_6_tmp_11_elem);
        }

        Nan::DefineOwnProperty(arg_0_6_tmp, Nan::New<String>("AdditionalBIPs").ToLocalChecked(), arg_0_6_tmp_11);

        arg_0_6 = arg_0_6_tmp;
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("bitcoinLikeNetworkParameters").ToLocalChecked(), arg_0_6);
    Local<Value> arg_0_7;
    if(result.cosmosLikeNetworkParameters)
    {
        auto arg_0_7_optional = (result.cosmosLikeNetworkParameters).value();
        auto arg_0_7_tmp = Nan::New<Object>();
        auto arg_0_7_tmp_1 = Nan::New<String>(arg_0_7_optional.Identifier).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("Identifier").ToLocalChecked(), arg_0_7_tmp_1);
        auto arg_0_7_tmp_2 = Nan::New<String>(arg_0_7_optional.MessagePrefix).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("MessagePrefix").ToLocalChecked(), arg_0_7_tmp_2);
        auto arg_0_7_tmp_3 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_7_optional.XPUBVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("XPUBVersion").ToLocalChecked(), arg_0_7_tmp_3);
        auto arg_0_7_tmp_4 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_7_optional.PubKeyPrefix)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("PubKeyPrefix").ToLocalChecked(), arg_0_7_tmp_4);
        auto arg_0_7_tmp_5 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_7_optional.Ed25519PubKeyPrefix)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("Ed25519PubKeyPrefix").ToLocalChecked(), arg_0_7_tmp_5);
        auto arg_0_7_tmp_6 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_7_optional.AddressPrefix)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("AddressPrefix").ToLocalChecked(), arg_0_7_tmp_6);
        auto arg_0_7_tmp_7 = Nan::New<String>(arg_0_7_optional.ChainId).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("ChainId").ToLocalChecked(), arg_0_7_tmp_7);
        Local<Array> arg_0_7_tmp_8 = Nan::New<Array>();
        for(size_t arg_0_7_tmp_8_id = 0; arg_0_7_tmp_8_id < arg_0_7_optional.AdditionalCIPs.size(); arg_0_7_tmp_8_id++)
        {
            auto arg_0_7_tmp_8_elem = Nan::New<String>(arg_0_7_optional.AdditionalCIPs[arg_0_7_tmp_8_id]).ToLocalChecked();
            Nan::Set(arg_0_7_tmp_8, (int)arg_0_7_tmp_8_id,arg_0_7_tmp_8_elem);
        }

        Nan::DefineOwnProperty(arg_0_7_tmp, Nan::New<String>("AdditionalCIPs").ToLocalChecked(), arg_0_7_tmp_8);

        arg_0_7 = arg_0_7_tmp;
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("cosmosLikeNetworkParameters").ToLocalChecked(), arg_0_7);
    Local<Value> arg_0_8;
    if(result.ethereumLikeNetworkParameters)
    {
        auto arg_0_8_optional = (result.ethereumLikeNetworkParameters).value();
        auto arg_0_8_tmp = Nan::New<Object>();
        auto arg_0_8_tmp_1 = Nan::New<String>(arg_0_8_optional.Identifier).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_8_tmp, Nan::New<String>("Identifier").ToLocalChecked(), arg_0_8_tmp_1);
        auto arg_0_8_tmp_2 = Nan::New<String>(arg_0_8_optional.MessagePrefix).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_8_tmp, Nan::New<String>("MessagePrefix").ToLocalChecked(), arg_0_8_tmp_2);
        auto arg_0_8_tmp_3 = Nan::New<String>(arg_0_8_optional.ChainID).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_8_tmp, Nan::New<String>("ChainID").ToLocalChecked(), arg_0_8_tmp_3);
        auto arg_0_8_tmp_4 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_8_optional.XPUBVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_8_tmp, Nan::New<String>("XPUBVersion").ToLocalChecked(), arg_0_8_tmp_4);
        Local<Array> arg_0_8_tmp_5 = Nan::New<Array>();
        for(size_t arg_0_8_tmp_5_id = 0; arg_0_8_tmp_5_id < arg_0_8_optional.AdditionalEIPs.size(); arg_0_8_tmp_5_id++)
        {
            auto arg_0_8_tmp_5_elem = Nan::New<String>(arg_0_8_optional.AdditionalEIPs[arg_0_8_tmp_5_id]).ToLocalChecked();
            Nan::Set(arg_0_8_tmp_5, (int)arg_0_8_tmp_5_id,arg_0_8_tmp_5_elem);
        }

        Nan::DefineOwnProperty(arg_0_8_tmp, Nan::New<String>("AdditionalEIPs").ToLocalChecked(), arg_0_8_tmp_5);
        auto arg_0_8_tmp_6 = Nan::New<Number>(arg_0_8_optional.TimestampDelay);
        Nan::DefineOwnProperty(arg_0_8_tmp, Nan::New<String>("TimestampDelay").ToLocalChecked(), arg_0_8_tmp_6);

        arg_0_8 = arg_0_8_tmp;
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("ethereumLikeNetworkParameters").ToLocalChecked(), arg_0_8);
    Local<Value> arg_0_9;
    if(result.rippleLikeNetworkParameters)
    {
        auto arg_0_9_optional = (result.rippleLikeNetworkParameters).value();
        auto arg_0_9_tmp = Nan::New<Object>();
        auto arg_0_9_tmp_1 = Nan::New<String>(arg_0_9_optional.Identifier).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_9_tmp, Nan::New<String>("Identifier").ToLocalChecked(), arg_0_9_tmp_1);
        auto arg_0_9_tmp_2 = Nan::New<String>(arg_0_9_optional.MessagePrefix).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_9_tmp, Nan::New<String>("MessagePrefix").ToLocalChecked(), arg_0_9_tmp_2);
        auto arg_0_9_tmp_3 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_9_optional.XPUBVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_9_tmp, Nan::New<String>("XPUBVersion").ToLocalChecked(), arg_0_9_tmp_3);
        Local<Array> arg_0_9_tmp_4 = Nan::New<Array>();
        for(size_t arg_0_9_tmp_4_id = 0; arg_0_9_tmp_4_id < arg_0_9_optional.AdditionalRIPs.size(); arg_0_9_tmp_4_id++)
        {
            auto arg_0_9_tmp_4_elem = Nan::New<String>(arg_0_9_optional.AdditionalRIPs[arg_0_9_tmp_4_id]).ToLocalChecked();
            Nan::Set(arg_0_9_tmp_4, (int)arg_0_9_tmp_4_id,arg_0_9_tmp_4_elem);
        }

        Nan::DefineOwnProperty(arg_0_9_tmp, Nan::New<String>("AdditionalRIPs").ToLocalChecked(), arg_0_9_tmp_4);
        auto arg_0_9_tmp_5 = Nan::New<Number>(arg_0_9_optional.TimestampDelay);
        Nan::DefineOwnProperty(arg_0_9_tmp, Nan::New<String>("TimestampDelay").ToLocalChecked(), arg_0_9_tmp_5);

        arg_0_9 = arg_0_9_tmp;
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("rippleLikeNetworkParameters").ToLocalChecked(), arg_0_9);
    Local<Value> arg_0_10;
    if(result.tezosLikeNetworkParameters)
    {
        auto arg_0_10_optional = (result.tezosLikeNetworkParameters).value();
        auto arg_0_10_tmp = Nan::New<Object>();
        auto arg_0_10_tmp_1 = Nan::New<String>(arg_0_10_optional.Identifier).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_10_tmp, Nan::New<String>("Identifier").ToLocalChecked(), arg_0_10_tmp_1);
        auto arg_0_10_tmp_2 = Nan::New<String>(arg_0_10_optional.MessagePrefix).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_10_tmp, Nan::New<String>("MessagePrefix").ToLocalChecked(), arg_0_10_tmp_2);
        auto arg_0_10_tmp_3 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_10_optional.XPUBVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_10_tmp, Nan::New<String>("XPUBVersion").ToLocalChecked(), arg_0_10_tmp_3);
        auto arg_0_10_tmp_4 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_10_optional.ImplicitPrefix)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_10_tmp, Nan::New<String>("ImplicitPrefix").ToLocalChecked(), arg_0_10_tmp_4);
        auto arg_0_10_tmp_5 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_10_optional.OriginatedPrefix)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_10_tmp, Nan::New<String>("OriginatedPrefix").ToLocalChecked(), arg_0_10_tmp_5);
        Local<Array> arg_0_10_tmp_6 = Nan::New<Array>();
        for(size_t arg_0_10_tmp_6_id = 0; arg_0_10_tmp_6_id < arg_0_10_optional.AdditionalTIPs.size(); arg_0_10_tmp_6_id++)
        {
            auto arg_0_10_tmp_6_elem = Nan::New<String>(arg_0_10_optional.AdditionalTIPs[arg_0_10_tmp_6_id]).ToLocalChecked();
            Nan::Set(arg_0_10_tmp_6, (int)arg_0_10_tmp_6_id,arg_0_10_tmp_6_elem);
        }

        Nan::DefineOwnProperty(arg_0_10_tmp, Nan::New<String>("AdditionalTIPs").ToLocalChecked(), arg_0_10_tmp_6);
        auto arg_0_10_tmp_7 = Nan::New<Number>(arg_0_10_optional.TimestampDelay);
        Nan::DefineOwnProperty(arg_0_10_tmp, Nan::New<String>("TimestampDelay").ToLocalChecked(), arg_0_10_tmp_7);

        arg_0_10 = arg_0_10_tmp;
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("tezosLikeNetworkParameters").ToLocalChecked(), arg_0_10);
    Local<Value> arg_0_11;
    if(result.stellarLikeNetworkParameters)
    {
        auto arg_0_11_optional = (result.stellarLikeNetworkParameters).value();
        auto arg_0_11_tmp = Nan::New<Object>();
        auto arg_0_11_tmp_1 = Nan::New<String>(arg_0_11_optional.Identifier).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_11_tmp, Nan::New<String>("Identifier").ToLocalChecked(), arg_0_11_tmp_1);
        auto arg_0_11_tmp_2 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_11_optional.Version)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_11_tmp, Nan::New<String>("Version").ToLocalChecked(), arg_0_11_tmp_2);
        auto arg_0_11_tmp_3 = Nan::New<String>("0x" + djinni::js::hex::toString(arg_0_11_optional.MuxedVersion)).ToLocalChecked();

        Nan::DefineOwnProperty(arg_0_11_tmp, Nan::New<String>("MuxedVersion").ToLocalChecked(), arg_0_11_tmp_3);
        auto arg_0_11_tmp_4 = Nan::New<Number>(arg_0_11_optional.BaseReserve);
        Nan::DefineOwnProperty(arg_0_11_tmp, Nan::New<String>("BaseReserve").ToLocalChecked(), arg_0_11_tmp_4);
        auto arg_0_11_tmp_5 = Nan::New<Number>(arg_0_11_optional.BaseFee);
        Nan::DefineOwnProperty(arg_0_11_tmp, Nan::New<String>("BaseFee").ToLocalChecked(), arg_0_11_tmp_5);
        Local<Array> arg_0_11_tmp_6 = Nan::New<Array>();
        for(size_t arg_0_11_tmp_6_id = 0; arg_0_11_tmp_6_id < arg_0_11_optional.AdditionalSEPs.size(); arg_0_11_tmp_6_id++)
        {
            auto arg_0_11_tmp_6_elem = Nan::New<String>(arg_0_11_optional.AdditionalSEPs[arg_0_11_tmp_6_id]).ToLocalChecked();
            Nan::Set(arg_0_11_tmp_6, (int)arg_0_11_tmp_6_id,arg_0_11_tmp_6_elem);
        }

        Nan::DefineOwnProperty(arg_0_11_tmp, Nan::New<String>("AdditionalSEPs").ToLocalChecked(), arg_0_11_tmp_6);
        auto arg_0_11_tmp_7 = Nan::New<String>(arg_0_11_optional.NetworkPassphrase).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_11_tmp, Nan::New<String>("NetworkPassphrase").ToLocalChecked(), arg_0_11_tmp_7);

        arg_0_11 = arg_0_11_tmp;
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("stellarLikeNetworkParameters").ToLocalChecked(), arg_0_11);
    Local<Value> arg_0_12;
    if(result.algorandNetworkParameters)
    {
        auto arg_0_12_optional = (result.algorandNetworkParameters).value();
        auto arg_0_12_tmp = Nan::New<Object>();
        auto arg_0_12_tmp_1 = Nan::New<String>(arg_0_12_optional.genesisID).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_12_tmp, Nan::New<String>("genesisID").ToLocalChecked(), arg_0_12_tmp_1);
        auto arg_0_12_tmp_2 = Nan::New<String>(arg_0_12_optional.genesisHash).ToLocalChecked();
        Nan::DefineOwnProperty(arg_0_12_tmp, Nan::New<String>("genesisHash").ToLocalChecked(), arg_0_12_tmp_2);

        arg_0_12 = arg_0_12_tmp;
    }

    Nan::DefineOwnProperty(arg_0, Nan::New<String>("algorandNetworkParameters").ToLocalChecked(), arg_0_12);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::isInstanceOfBitcoinLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfBitcoinLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfBitcoinLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->isInstanceOfBitcoinLikeWallet();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::isInstanceOfAlgorandLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfAlgorandLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfAlgorandLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->isInstanceOfAlgorandLikeWallet();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::isInstanceOfCosmosLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfCosmosLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfCosmosLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->isInstanceOfCosmosLikeWallet();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::isInstanceOfEthereumLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfEthereumLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfEthereumLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->isInstanceOfEthereumLikeWallet();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::isInstanceOfRippleLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfRippleLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfRippleLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->isInstanceOfRippleLikeWallet();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::isInstanceOfStellarLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfStellarLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::isInstanceOfStellarLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->isInstanceOfStellarLikeWallet();

    //Wrap result in node object
    auto arg_0 = Nan::New<Boolean>(result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::asStellarLikeWallet) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::asStellarLikeWallet needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::asStellarLikeWallet : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->asStellarLikeWallet();

    //Wrap result in node object
    auto arg_0 = NJSStellarLikeWallet::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::getWalletType) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getWalletType needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getWalletType : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getWalletType();

    //Wrap result in node object
    auto arg_0 = Nan::New<Integer>((int)result);

    //Return result
    info.GetReturnValue().Set(arg_0);
}
NAN_METHOD(NJSWallet::getLastBlock) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getLastBlock needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSBlockCallback *njs_ptr_arg_0 = new NJSBlockCallback(arg_0_resolver);
    std::shared_ptr<NJSBlockCallback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getLastBlock : implementation of Wallet is not valid");
    }
    cpp_impl->getLastBlock(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getAccountCreationInfo) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSWallet::getAccountCreationInfo needs 1 arguments");
    }

    //Check if parameters have correct types
    auto arg_0 = Nan::To<int32_t>(info[0]).FromJust();

    //Create promise and set it into Callback
    auto arg_1_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAccountCreationInfoCallback *njs_ptr_arg_1 = new NJSAccountCreationInfoCallback(arg_1_resolver);
    std::shared_ptr<NJSAccountCreationInfoCallback> arg_1(njs_ptr_arg_1);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getAccountCreationInfo : implementation of Wallet is not valid");
    }
    cpp_impl->getAccountCreationInfo(arg_0,arg_1);
    info.GetReturnValue().Set(arg_1_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getExtendedKeyAccountCreationInfo) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSWallet::getExtendedKeyAccountCreationInfo needs 1 arguments");
    }

    //Check if parameters have correct types
    auto arg_0 = Nan::To<int32_t>(info[0]).FromJust();

    //Create promise and set it into Callback
    auto arg_1_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSExtendedKeyAccountCreationInfoCallback *njs_ptr_arg_1 = new NJSExtendedKeyAccountCreationInfoCallback(arg_1_resolver);
    std::shared_ptr<NJSExtendedKeyAccountCreationInfoCallback> arg_1(njs_ptr_arg_1);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getExtendedKeyAccountCreationInfo : implementation of Wallet is not valid");
    }
    cpp_impl->getExtendedKeyAccountCreationInfo(arg_0,arg_1);
    info.GetReturnValue().Set(arg_1_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getNextAccountCreationInfo) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getNextAccountCreationInfo needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAccountCreationInfoCallback *njs_ptr_arg_0 = new NJSAccountCreationInfoCallback(arg_0_resolver);
    std::shared_ptr<NJSAccountCreationInfoCallback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getNextAccountCreationInfo : implementation of Wallet is not valid");
    }
    cpp_impl->getNextAccountCreationInfo(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getNextExtendedKeyAccountCreationInfo) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getNextExtendedKeyAccountCreationInfo needs 0 arguments");
    }

    //Check if parameters have correct types

    //Create promise and set it into Callback
    auto arg_0_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSExtendedKeyAccountCreationInfoCallback *njs_ptr_arg_0 = new NJSExtendedKeyAccountCreationInfoCallback(arg_0_resolver);
    std::shared_ptr<NJSExtendedKeyAccountCreationInfoCallback> arg_0(njs_ptr_arg_0);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getNextExtendedKeyAccountCreationInfo : implementation of Wallet is not valid");
    }
    cpp_impl->getNextExtendedKeyAccountCreationInfo(arg_0);
    info.GetReturnValue().Set(arg_0_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::newAccountWithInfo) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSWallet::newAccountWithInfo needs 1 arguments");
    }

    //Check if parameters have correct types

    auto field_arg_0_1 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("index").ToLocalChecked()).ToLocalChecked();
    auto arg_0_1 = Nan::To<int32_t>(field_arg_0_1).FromJust();

    auto field_arg_0_2 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("owners").ToLocalChecked()).ToLocalChecked();
    vector<std::string> arg_0_2;
    Local<Array> arg_0_2_container = Local<Array>::Cast(field_arg_0_2);
    for(uint32_t arg_0_2_id = 0; arg_0_2_id < arg_0_2_container->Length(); arg_0_2_id++)
    {
        if(arg_0_2_container->Get(Nan::GetCurrentContext(), arg_0_2_id).ToLocalChecked()->IsString())
        {
            Nan::Utf8String string_arg_0_2_elem(arg_0_2_container->Get(Nan::GetCurrentContext(), arg_0_2_id).ToLocalChecked()->ToString(Nan::GetCurrentContext()).ToLocalChecked());
            auto arg_0_2_elem = std::string(*string_arg_0_2_elem);
            arg_0_2.emplace_back(arg_0_2_elem);
        }
    }


    auto field_arg_0_3 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("derivations").ToLocalChecked()).ToLocalChecked();
    vector<std::string> arg_0_3;
    Local<Array> arg_0_3_container = Local<Array>::Cast(field_arg_0_3);
    for(uint32_t arg_0_3_id = 0; arg_0_3_id < arg_0_3_container->Length(); arg_0_3_id++)
    {
        if(arg_0_3_container->Get(Nan::GetCurrentContext(), arg_0_3_id).ToLocalChecked()->IsString())
        {
            Nan::Utf8String string_arg_0_3_elem(arg_0_3_container->Get(Nan::GetCurrentContext(), arg_0_3_id).ToLocalChecked()->ToString(Nan::GetCurrentContext()).ToLocalChecked());
            auto arg_0_3_elem = std::string(*string_arg_0_3_elem);
            arg_0_3.emplace_back(arg_0_3_elem);
        }
    }


    auto field_arg_0_4 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("publicKeys").ToLocalChecked()).ToLocalChecked();
    vector<std::vector<uint8_t>> arg_0_4;
    Local<Array> arg_0_4_container = Local<Array>::Cast(field_arg_0_4);
    for(uint32_t arg_0_4_id = 0; arg_0_4_id < arg_0_4_container->Length(); arg_0_4_id++)
    {
        if(arg_0_4_container->Get(Nan::GetCurrentContext(), arg_0_4_id).ToLocalChecked()->IsString())
        {
            if(!arg_0_4_container->Get(Nan::GetCurrentContext(), arg_0_4_id).ToLocalChecked()->IsString())
            {
                Nan::ThrowError("arg_0_4_container->Get(Nan::GetCurrentContext(), arg_0_4_id).ToLocalChecked() should be a hexadecimal string.");
            }
            std::vector<uint8_t> arg_0_4_elem;
            Nan::Utf8String str_arg_0_4_elem(arg_0_4_container->Get(Nan::GetCurrentContext(), arg_0_4_id).ToLocalChecked());
            std::string string_arg_0_4_elem(*str_arg_0_4_elem, str_arg_0_4_elem.length());
            if (string_arg_0_4_elem.rfind("0x", 0) == 0)
            {
                arg_0_4_elem = djinni::js::hex::toByteArray(string_arg_0_4_elem.substr(2));
            }
            else
            {
                arg_0_4_elem = std::vector<uint8_t>(string_arg_0_4_elem.cbegin(), string_arg_0_4_elem.cend());
            }

            arg_0_4.emplace_back(arg_0_4_elem);
        }
    }


    auto field_arg_0_5 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("chainCodes").ToLocalChecked()).ToLocalChecked();
    vector<std::vector<uint8_t>> arg_0_5;
    Local<Array> arg_0_5_container = Local<Array>::Cast(field_arg_0_5);
    for(uint32_t arg_0_5_id = 0; arg_0_5_id < arg_0_5_container->Length(); arg_0_5_id++)
    {
        if(arg_0_5_container->Get(Nan::GetCurrentContext(), arg_0_5_id).ToLocalChecked()->IsString())
        {
            if(!arg_0_5_container->Get(Nan::GetCurrentContext(), arg_0_5_id).ToLocalChecked()->IsString())
            {
                Nan::ThrowError("arg_0_5_container->Get(Nan::GetCurrentContext(), arg_0_5_id).ToLocalChecked() should be a hexadecimal string.");
            }
            std::vector<uint8_t> arg_0_5_elem;
            Nan::Utf8String str_arg_0_5_elem(arg_0_5_container->Get(Nan::GetCurrentContext(), arg_0_5_id).ToLocalChecked());
            std::string string_arg_0_5_elem(*str_arg_0_5_elem, str_arg_0_5_elem.length());
            if (string_arg_0_5_elem.rfind("0x", 0) == 0)
            {
                arg_0_5_elem = djinni::js::hex::toByteArray(string_arg_0_5_elem.substr(2));
            }
            else
            {
                arg_0_5_elem = std::vector<uint8_t>(string_arg_0_5_elem.cbegin(), string_arg_0_5_elem.cend());
            }

            arg_0_5.emplace_back(arg_0_5_elem);
        }
    }

    AccountCreationInfo arg_0(arg_0_1, arg_0_2, arg_0_3, arg_0_4, arg_0_5);


    //Create promise and set it into Callback
    auto arg_1_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAccountCallback *njs_ptr_arg_1 = new NJSAccountCallback(arg_1_resolver);
    std::shared_ptr<NJSAccountCallback> arg_1(njs_ptr_arg_1);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::newAccountWithInfo : implementation of Wallet is not valid");
    }
    cpp_impl->newAccountWithInfo(arg_0,arg_1);
    info.GetReturnValue().Set(arg_1_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::newAccountWithExtendedKeyInfo) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSWallet::newAccountWithExtendedKeyInfo needs 1 arguments");
    }

    //Check if parameters have correct types

    auto field_arg_0_1 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("index").ToLocalChecked()).ToLocalChecked();
    auto arg_0_1 = Nan::To<int32_t>(field_arg_0_1).FromJust();

    auto field_arg_0_2 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("owners").ToLocalChecked()).ToLocalChecked();
    vector<std::string> arg_0_2;
    Local<Array> arg_0_2_container = Local<Array>::Cast(field_arg_0_2);
    for(uint32_t arg_0_2_id = 0; arg_0_2_id < arg_0_2_container->Length(); arg_0_2_id++)
    {
        if(arg_0_2_container->Get(Nan::GetCurrentContext(), arg_0_2_id).ToLocalChecked()->IsString())
        {
            Nan::Utf8String string_arg_0_2_elem(arg_0_2_container->Get(Nan::GetCurrentContext(), arg_0_2_id).ToLocalChecked()->ToString(Nan::GetCurrentContext()).ToLocalChecked());
            auto arg_0_2_elem = std::string(*string_arg_0_2_elem);
            arg_0_2.emplace_back(arg_0_2_elem);
        }
    }


    auto field_arg_0_3 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("derivations").ToLocalChecked()).ToLocalChecked();
    vector<std::string> arg_0_3;
    Local<Array> arg_0_3_container = Local<Array>::Cast(field_arg_0_3);
    for(uint32_t arg_0_3_id = 0; arg_0_3_id < arg_0_3_container->Length(); arg_0_3_id++)
    {
        if(arg_0_3_container->Get(Nan::GetCurrentContext(), arg_0_3_id).ToLocalChecked()->IsString())
        {
            Nan::Utf8String string_arg_0_3_elem(arg_0_3_container->Get(Nan::GetCurrentContext(), arg_0_3_id).ToLocalChecked()->ToString(Nan::GetCurrentContext()).ToLocalChecked());
            auto arg_0_3_elem = std::string(*string_arg_0_3_elem);
            arg_0_3.emplace_back(arg_0_3_elem);
        }
    }


    auto field_arg_0_4 = Nan::Get(info[0]->ToObject(Nan::GetCurrentContext()).ToLocalChecked(), Nan::New<String>("extendedKeys").ToLocalChecked()).ToLocalChecked();
    vector<std::string> arg_0_4;
    Local<Array> arg_0_4_container = Local<Array>::Cast(field_arg_0_4);
    for(uint32_t arg_0_4_id = 0; arg_0_4_id < arg_0_4_container->Length(); arg_0_4_id++)
    {
        if(arg_0_4_container->Get(Nan::GetCurrentContext(), arg_0_4_id).ToLocalChecked()->IsString())
        {
            Nan::Utf8String string_arg_0_4_elem(arg_0_4_container->Get(Nan::GetCurrentContext(), arg_0_4_id).ToLocalChecked()->ToString(Nan::GetCurrentContext()).ToLocalChecked());
            auto arg_0_4_elem = std::string(*string_arg_0_4_elem);
            arg_0_4.emplace_back(arg_0_4_elem);
        }
    }

    ExtendedKeyAccountCreationInfo arg_0(arg_0_1, arg_0_2, arg_0_3, arg_0_4);


    //Create promise and set it into Callback
    auto arg_1_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSAccountCallback *njs_ptr_arg_1 = new NJSAccountCallback(arg_1_resolver);
    std::shared_ptr<NJSAccountCallback> arg_1(njs_ptr_arg_1);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::newAccountWithExtendedKeyInfo : implementation of Wallet is not valid");
    }
    cpp_impl->newAccountWithExtendedKeyInfo(arg_0,arg_1);
    info.GetReturnValue().Set(arg_1_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::eraseDataSince) {

    //Check if method called with right number of arguments
    if(info.Length() != 1)
    {
        return Nan::ThrowError("NJSWallet::eraseDataSince needs 1 arguments");
    }

    //Check if parameters have correct types
    auto time_arg_0 = Nan::To<int32_t>(info[0]).FromJust();
    auto arg_0 = chrono::system_clock::time_point(chrono::milliseconds(time_arg_0));

    //Create promise and set it into Callback
    auto arg_1_resolver = v8::Promise::Resolver::New(Nan::GetCurrentContext()).ToLocalChecked();
    NJSErrorCodeCallback *njs_ptr_arg_1 = new NJSErrorCodeCallback(arg_1_resolver);
    std::shared_ptr<NJSErrorCodeCallback> arg_1(njs_ptr_arg_1);


    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::eraseDataSince : implementation of Wallet is not valid");
    }
    cpp_impl->eraseDataSince(arg_0,arg_1);
    info.GetReturnValue().Set(arg_1_resolver->GetPromise());
}
NAN_METHOD(NJSWallet::getConfiguration) {

    //Check if method called with right number of arguments
    if(info.Length() != 0)
    {
        return Nan::ThrowError("NJSWallet::getConfiguration needs 0 arguments");
    }

    //Check if parameters have correct types

    //Unwrap current object and retrieve its Cpp Implementation
    auto cpp_impl = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    if(!cpp_impl)
    {
        return Nan::ThrowError("NJSWallet::getConfiguration : implementation of Wallet is not valid");
    }

    auto result = cpp_impl->getConfiguration();

    //Wrap result in node object
    auto arg_0 = NJSDynamicObject::wrap(result);


    //Return result
    info.GetReturnValue().Set(arg_0);
}

NAN_METHOD(NJSWallet::New) {
    //Only new allowed
    if(!info.IsConstructCall())
    {
        return Nan::ThrowError("NJSWallet function can only be called as constructor (use New)");
    }
    info.GetReturnValue().Set(info.This());
}


Nan::Persistent<ObjectTemplate> NJSWallet::Wallet_prototype;

Local<Object> NJSWallet::wrap(const std::shared_ptr<ledger::core::api::Wallet> &object) {
    Nan::EscapableHandleScope scope;
    Local<ObjectTemplate> local_prototype = Nan::New(Wallet_prototype);

    Local<Object> obj;
    if(!local_prototype.IsEmpty())
    {
        obj = local_prototype->NewInstance(Nan::GetCurrentContext()).ToLocalChecked();
        djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Wrap(object, obj);
    }
    else
    {
        Nan::ThrowError("NJSWallet::wrap: object template not valid");
    }
    return scope.Escape(obj);
}

NAN_METHOD(NJSWallet::isNull) {
    auto cpp_implementation = djinni::js::ObjectWrapper<ledger::core::api::Wallet>::Unwrap(info.This());
    auto isNull = !cpp_implementation ? true : false;
    return info.GetReturnValue().Set(Nan::New<Boolean>(isNull));
}

void NJSWallet::Initialize(Local<Object> target) {
    Nan::HandleScope scope;

    Local<FunctionTemplate> func_template = Nan::New<FunctionTemplate>(NJSWallet::New);
    Local<ObjectTemplate> objectTemplate = func_template->InstanceTemplate();
    objectTemplate->SetInternalFieldCount(1);

    func_template->SetClassName(Nan::New<String>("NJSWallet").ToLocalChecked());

    //SetPrototypeMethod all methods
    Nan::SetPrototypeMethod(func_template,"getName", getName);
    Nan::SetPrototypeMethod(func_template,"getAccount", getAccount);
    Nan::SetPrototypeMethod(func_template,"getAccountCount", getAccountCount);
    Nan::SetPrototypeMethod(func_template,"getAccounts", getAccounts);
    Nan::SetPrototypeMethod(func_template,"getNextAccountIndex", getNextAccountIndex);
    Nan::SetPrototypeMethod(func_template,"getEventBus", getEventBus);
    Nan::SetPrototypeMethod(func_template,"isSynchronizing", isSynchronizing);
    Nan::SetPrototypeMethod(func_template,"synchronize", synchronize);
    Nan::SetPrototypeMethod(func_template,"getPreferences", getPreferences);
    Nan::SetPrototypeMethod(func_template,"getLogger", getLogger);
    Nan::SetPrototypeMethod(func_template,"getAccountPreferences", getAccountPreferences);
    Nan::SetPrototypeMethod(func_template,"asBitcoinLikeWallet", asBitcoinLikeWallet);
    Nan::SetPrototypeMethod(func_template,"asCosmosLikeWallet", asCosmosLikeWallet);
    Nan::SetPrototypeMethod(func_template,"getCurrency", getCurrency);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfBitcoinLikeWallet", isInstanceOfBitcoinLikeWallet);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfAlgorandLikeWallet", isInstanceOfAlgorandLikeWallet);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfCosmosLikeWallet", isInstanceOfCosmosLikeWallet);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfEthereumLikeWallet", isInstanceOfEthereumLikeWallet);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfRippleLikeWallet", isInstanceOfRippleLikeWallet);
    Nan::SetPrototypeMethod(func_template,"isInstanceOfStellarLikeWallet", isInstanceOfStellarLikeWallet);
    Nan::SetPrototypeMethod(func_template,"asStellarLikeWallet", asStellarLikeWallet);
    Nan::SetPrototypeMethod(func_template,"getWalletType", getWalletType);
    Nan::SetPrototypeMethod(func_template,"getLastBlock", getLastBlock);
    Nan::SetPrototypeMethod(func_template,"getAccountCreationInfo", getAccountCreationInfo);
    Nan::SetPrototypeMethod(func_template,"getExtendedKeyAccountCreationInfo", getExtendedKeyAccountCreationInfo);
    Nan::SetPrototypeMethod(func_template,"getNextAccountCreationInfo", getNextAccountCreationInfo);
    Nan::SetPrototypeMethod(func_template,"getNextExtendedKeyAccountCreationInfo", getNextExtendedKeyAccountCreationInfo);
    Nan::SetPrototypeMethod(func_template,"newAccountWithInfo", newAccountWithInfo);
    Nan::SetPrototypeMethod(func_template,"newAccountWithExtendedKeyInfo", newAccountWithExtendedKeyInfo);
    Nan::SetPrototypeMethod(func_template,"eraseDataSince", eraseDataSince);
    Nan::SetPrototypeMethod(func_template,"getConfiguration", getConfiguration);
    Nan::SetPrototypeMethod(func_template,"isNull", isNull);
    //Set object prototype
    Wallet_prototype.Reset(objectTemplate);

    //Add template to target
    Nan::Set(target, Nan::New<String>("NJSWallet").ToLocalChecked(), Nan::GetFunction(func_template).ToLocalChecked());
}
